Edje Perspective

- Main Page
- Related Pages
- Modules
- Data Structures
- Files
- Examples

Functions
Edje Perspective
Edje » Edje Object

Functions that deal with 3D projection of an 2D object. More...

## Functions
Edje_Perspective * | edje_perspective_new (Evas *e)
| Creates a new perspective in the given canvas.
void | edje_perspective_free (Edje_Perspective *ps)
| Deletes the given perspective object.
void | edje_perspective_set (Edje_Perspective *ps, Evas_Coord px, Evas_Coord py, Evas_Coord z0, Evas_Coord foc)
| Sets up the transform for this perspective object.
void | edje_perspective_global_set (Edje_Perspective *ps, Eina_Bool global)
| Makes this perspective object be global for its canvas.
Eina_Bool | edje_perspective_global_get (const Edje_Perspective *ps)
| Gets whether the given perspective object is global or not.
const Edje_Perspective * | edje_evas_global_perspective_get (const Evas *e)
| Gets the global perspective object set for this canvas.
void | edje_object_perspective_set (Evas_Object *obj, Edje_Perspective *ps)
| Sets the given perspective object on this Edje object.
const Edje_Perspective * | edje_object_perspective_get (const Evas_Object *obj)
| Gets the current perspective used on this Edje object.

## Detailed Description

Functions that deal with 3D projection of an 2D object.

## Function Documentation

## ◆ edje_perspective_new()

Edje_Perspective * edje_perspective_new | ( | Evas * | e | ) |

Creates a new perspective in the given canvas.

Parameters

  e | The given canvas (Evas).

Returns
  An Edje Perspective object for this canvas, or `NULL` on errors.

This function creates a perspective object that can be set on an Edje object, or globally to all Edje objects on this canvas.

See also
  edje_perspective_set()
  edje_perspective_free()

Examples
  edje-perspective.c.

References EVAS_CALLBACK_DEL, evas_object_data_set(), evas_object_event_callback_add(), evas_object_rectangle_add(), and evas_output_viewport_get().

## ◆ edje_perspective_free()

void edje_perspective_free | ( | Edje_Perspective * | ps | ) |

Deletes the given perspective object.

Parameters

  ps | A valid perspective object, or `NULL`.

This function will delete the perspective object. If the perspective effect was being applied to any Edje object or part, this effect won't be applied anymore.

See also
  edje_perspective_new()

References evas_object_del().

## ◆ edje_perspective_set()

void edje_perspective_set | ( | Edje_Perspective * | ps,
|  | Evas_Coord | px,
|  | Evas_Coord | py,
|  | Evas_Coord | z0,
|  | Evas_Coord | foc
| ) |  |

Sets up the transform for this perspective object.

This sets the parameters of the perspective transformation. X, Y and Z values are used. The px and py points specify the "infinite distance" point in the 3D conversion (where all lines converge to like when artists draw 3D by hand). The `z0` value specifies the z value at which there is a 1:1 mapping between spatial coordinates and screen coordinates. Any points on this z value will not have their X and Y values modified in the transform. Those further away (Z value higher) will shrink into the distance, and those less than this value will expand and become bigger. The `foc` value determines the "focal length" of the camera. This is in reality the distance between the camera lens plane itself (at or closer than this rendering results are undefined) and the "z0" z value. This allows for some "depth" control and `foc` must be greater than 0.

Parameters

  ps | The perspective object
  px | The perspective distance X coordinate
  py | The perspective distance Y coordinate
  z0 | The "0" z plane value
  foc | The focal distance

Examples
  edje-perspective.c.

References EINA_INLIST_FOREACH, EINA_LIST_FOREACH, and EINA_TRUE.

## ◆ edje_perspective_global_set()

void edje_perspective_global_set | ( | Edje_Perspective * | ps,
|  | Eina_Bool | global
| ) |  |

Makes this perspective object be global for its canvas.

Parameters

  ps | The given perspective object
  global | `EINA_TRUE` if the perspective should be global, `EINA_FALSE` otherwise.

The canvas which this perspective object is being set as global is the one given as argument upon the object creation (the `evas` parameter on the function `edje_perspective_new(evas)` ).

There can be only one global perspective object set per canvas, and if a perspective object is set to global when there was already another global perspective set, the old one will be set as non-global.

A global perspective just affects a part if its Edje object doesn't have a perspective object set to it, and if the part doesn't point to another part to be used as perspective.

See also
  edje_object_perspective_set()
  edje_perspective_global_get()
  edje_perspective_new()

Examples
  edje-perspective.c.

References EINA_INLIST_FOREACH, EINA_TRUE, evas_object_evas_get(), evas_object_name_find(), and evas_object_name_set().

## ◆ edje_perspective_global_get()

Eina_Bool edje_perspective_global_get | ( | const Edje_Perspective * | ps | ) |

Gets whether the given perspective object is global or not.

Parameters

  ps | The given perspective object.

Returns
  `EINA_TRUE` if this perspective object is global, `EINA_FALSE` otherwise.

See also
  edje_perspective_global_set()

References EINA_FALSE.

## ◆ edje_evas_global_perspective_get()

const Edje_Perspective * edje_evas_global_perspective_get | ( | const Evas * | e | ) |

Gets the global perspective object set for this canvas.

Parameters

  e | The given canvas (Evas).

Returns
  The perspective object set as global for this canvas. Or `NULL` if there is no global perspective set and on errors.

This function will return the perspective object that was set as global with edje_perspective_global_set().

See also
  edje_perspective_global_set()
  edje_perspective_global_get()

References evas_object_name_find().

## ◆ edje_object_perspective_set()

void edje_object_perspective_set | ( | Evas_Object * | obj,
|  | Edje_Perspective * | ps
| ) |  |

Sets the given perspective object on this Edje object.

Make the given perspective object be the default perspective for this Edje object.

There can be only one perspective object per Edje object, and if a previous one was set, it will be removed and the new perspective object will be used.

An Edje perspective will only affect a part if it doesn't point to another part to be used as perspective.

edje_object_perspective_new() See also edje_object_perspective_get() edje_perspective_set()

Parameters

  [in] | obj | The object.
  [in] | ps | The perspective object that will be used.

References eina_list_append(), eina_list_remove(), and EINA_TRUE.

## ◆ edje_object_perspective_get()

const Edje_Perspective * edje_object_perspective_get | ( | const Evas_Object * | obj | ) |

Gets the current perspective used on this Edje object.

See also edje_object_perspective_set()

Parameters

  [in] | obj | The object.

Returns
  The perspective object that will be used.